Bug 198277

Summary: Audio stops playing when standalone web app is no longer in foreground
Product: WebKit Reporter: Wes <wes>
Component: MediaAssignee: Nobody <webkit-unassigned>
Status: NEW ---    
Severity: Normal CC: adel.abdelli.aa, alex7golovin, bernardo.oliveira, brian+webkitbugzilla, cass, eric.carlson, herr.ernst, ibeatnorris, icid.asset, isabelle, jer.noble, j.jeanroy, jon, joshterry55, kubadrynkowski, martin.spriggs, matt, mjs, orlachpierre, pedro.felipe.azevedo.furtado, thalleshmmaia, t.pruvot, webkit-bug-importer, webkit, wes, zienag
Priority: P2 Keywords: InRadar
Version: Safari 12   
Hardware: iPhone / iPad   
OS: iOS 12   

Description Wes 2019-05-27 10:40:25 PDT
Simple repro site at https://ios-standalone-bug.backgroundnoise.app

1. Write a web app that Includes an HTML <audio> element
2. Pin it to home screen on iOS with display:standalone in manifest.json
3. Launch the web app
4. Play the audio
5. Leave the web app

Expected:
Audio keeps playing

Actual:
Audio stops playing.

NOTE: If you play the audio in Safari and leave Safari it keeps playing in the background. This only affects standalone web apps/PWAs
Comment 1 Radar WebKit Bug Importer 2019-05-28 17:18:42 PDT
<rdar://problem/51202332>
Comment 2 Thalles Maia 2019-06-24 07:22:49 PDT
I'm also having this problem on https://podcatcher.app/
Comment 3 martin.spriggs 2019-09-19 15:31:07 PDT
Please get this on somebody's list. We have a very popular PWA with limited functionality on iOS 13 due to no background audio!
Comment 4 Alfred 2019-09-26 08:43:10 PDT
We use WKWebView in our app, and we also have this bug. I've looked sources for a little, and it seems that it is not actually a webkit bug, but something in iOS. Safari manages media via some complicated mechanisms, so it doesn't reproduces there.
Comment 5 Val Mitchell 2019-10-30 07:01:46 PDT
Please get somebody to work on the fix for this issue, this bug blatantly prevents users to have the same experience as native app users.
Comment 6 Orlach Pierre 2019-11-08 09:44:08 PST
Same Problem on my progressive Web app based on audio content. It was perfectly working with previous IOS. It's a huge step backwards for user experience.
Comment 7 Jon Levy 2019-11-24 14:44:54 PST
This is a big problem for our PWA, as well.
Comment 8 Jakub 2019-11-26 07:00:44 PST
I'm having this issue also we need to develop an only native app for Apple other support audio in the backgroung
Comment 9 isabelle 2020-01-08 04:57:46 PST
I'm also having this problem on https://podcasts.ba-ba-bam.com/be-lively-lexperience-bien-etre/
Comment 10 Jer Noble 2020-01-15 08:22:43 PST
Hi everyone, just a quick update: we have been investigating this issue but don’t yet have a solution. We understand that the current behavior blocks a lot of important use cases. But because the issues causing this behavior may be due to the underlying platform, investigation is being tracked inside Radar, rather than here on bugzilla. If we do identify a fix, we’ll ping this thread when that fix is available for testing. Thanks for your patience.
Comment 11 Jon Levy 2020-01-15 08:35:22 PST
(In reply to Jer Noble from comment #10)
It is wonderful to hear that this issue is being investigated!  Thank you for your hard work.  Is there a link to the bug report on Radar, so that I can track the progress?
Comment 12 Maciej Stachowiak 2020-03-24 21:30:41 PDT
Following some internal info trails, I believe this is a dupe of https://bugs.webkit.org/show_bug.cgi?id=205687 and thus resolved (but not yet in a release). I will confirm with an internal build before duping, and I’ll see what we can do about getting the fix in an update.
Comment 13 brian+webkitbugzilla 2020-04-08 14:05:50 PDT
(In reply to Maciej Stachowiak from comment #12)
> Following some internal info trails, I believe this is a dupe of
> https://bugs.webkit.org/show_bug.cgi?id=205687 and thus resolved (but not
> yet in a release). I will confirm with an internal build before duping, and
> I’ll see what we can do about getting the fix in an update.

Did you end up confirming that #205687 fixes this issue? I'm sure there are hundreds of engineers and many thousands of users who are eager to hear updates about whether this is fixed in an upcoming release.

Thanks in advance,
Brian.
Comment 14 JTerr 2020-04-15 13:52:27 PDT
(In reply to Maciej Stachowiak from comment #12)
> Following some internal info trails, I believe this is a dupe of
> https://bugs.webkit.org/show_bug.cgi?id=205687 and thus resolved (but not
> yet in a release). I will confirm with an internal build before duping, and
> I’ll see what we can do about getting the fix in an update.

Hey have you found any fix for this? I have also been searching for months for a fix on this. Our app has many audios and all of them cannot be used inside our WKWebView 30 seconds after app goes into background/screen goes black, the audio cuts out. Would love to see a fix coming on this. Thank you!
Comment 15 Jon Levy 2020-04-15 13:56:56 PDT
(In reply to Maciej Stachowiak from comment #12)
This is a big issue for our app (like numerous others).  It would be great to know if this has been resolved, and, if so, when it will be released.  Thank you for your efforts.
Comment 16 Orlach Pierre 2020-04-22 04:06:54 PDT
Hello, Big issue for us also. Could you confirm that the bug will be fix in the next update?
Comment 17 Julie J 2020-04-27 09:52:54 PDT
Hello, this is a big issue for our Progressive Web App as well, could you confirm if the bug is going to be fix during the next update ?
Comment 18 brian+webkitbugzilla 2020-06-02 13:13:50 PDT
Maciej Stachowiak, following up here -- what is the latest status of this issue? It doesn't look like the alleged fix made it in 13.5, or at least if it has, it has not fixed this issue.
Comment 19 brian+webkitbugzilla 2020-06-02 18:52:09 PDT
Apparently https://bugs.webkit.org/show_bug.cgi?id=205687 shipped in 13.5.1, and this issue (audio stops playing when standalone web app is no longer in foreground) was not fixed. So these are duplicates, and the issue remains unfixed.
Comment 20 JTerr 2020-06-02 18:58:18 PDT
After iOS 13.5.1 this does appear to still not be working. Any update on this in the near future? It seems to have been broken since September. Thank you!
Comment 21 alex7golovin 2020-06-16 09:15:43 PDT
Waiting for this fix for our PWA which has audio content
Comment 22 Bernardo Oliveira 2020-06-16 15:15:36 PDT
(In reply to Maciej Stachowiak from comment #12)
> Following some internal info trails, I believe this is a dupe of
> https://bugs.webkit.org/show_bug.cgi?id=205687 and thus resolved (but not
> yet in a release). I will confirm with an internal build before duping, and
> I’ll see what we can do about getting the fix in an update.

Here I'm using the iOS 13.5.1 and audio stops playing when a standalone web app is no longer in the foreground or in lock screen. Any updates on this? Really thank you!!
Comment 23 Adel Abdelli 2020-06-22 02:30:42 PDT
This issue is very problematic for our company ...
Any update about it :( ?
Comment 24 Thomas Pruvot 2020-06-29 02:37:19 PDT
Hello, is this problem will be fix soon?
Does someone have informations on it ?
Thanks
Comment 25 Cass 2020-07-10 15:18:18 PDT
Bump -- does anyone have any information on whether or not iOS 14 will bring support for this feature?
Comment 26 Cybronics 2020-07-13 06:56:21 PDT
(In reply to Cass from comment #25)
> Bump -- does anyone have any information on whether or not iOS 14 will bring
> support for this feature?

seems to be fixed in iOS 14 Beta 2
Comment 27 Wes 2020-07-13 07:29:09 PDT
> seems to be fixed in iOS 14 Beta 2

I am using iOS 14 Beta 2 and this is not fixed for me (I'm following the repro steps exactly).
Comment 28 Cybronics 2020-07-13 07:32:35 PDT
(In reply to Wes Peter from comment #27)
> > seems to be fixed in iOS 14 Beta 2
> 
> I am using iOS 14 Beta 2 and this is not fixed for me (I'm following the
> repro steps exactly).

Indeed. Only fixed if web app is launched through a webview from a native app, not if it is directly installed from Safari.
Comment 29 Ernst 2020-08-20 01:44:13 PDT
Unfortunately, this is still not fixed in iPadOS 14 Beta 5, which basically renders our progressive web app useless :(

Apple, please allow playing audio in the background for a standalone web app!
Comment 30 Pedro Furtado 2020-08-20 04:26:15 PDT
The same frustration here. Not fixed in Iphone and iPad 14 Beta. Anyone can help us? Reopening the bug and prioritize it in release?
Comment 31 Jon Levy 2020-08-20 06:49:18 PDT
+1 on the request that Apple support background play from PWAs.
Comment 32 Bernardo Oliveira 2020-09-23 02:14:08 PDT
Any news from the team on this issue? I know there are things that take longer than expected but it's been over a year and it seems like no one is giving any importance to this. I know that Apple doesn't have much love for PWA, but come on we are dealing with a basic need, sound. There are so many apps waiting for this around the world. I would love to have someone from the team give a little more detail, focus and love on this.
Comment 33 Pedro Furtado 2020-09-23 04:15:24 PDT
Any news about it? Not fixed in IOS 14 / iPadOS 14.